# IBM Confidential
# OCO Source Materials
# Rational ClearCase
# (C) Copyright IBM Corp. 1996, 2008
#
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#
#
# ------------------------------------------------------------------
# | Copyright Unpublished, Atria Software, Inc.  All Rights        |
# | Reserved.  This software contains proprietary and confidential |
# | information of Atria and its suppliers.  Use, disclosure or    |
# | reproduction is prohibited without the prior express written   |
# | consent of Atria.  Subject to RESTRICTED RIGHTS for US         |
# | Government users.                                              |
# ------------------------------------------------------------------
#
use Socket;
#
# Atrit home is passe din from the start up bat scripts.
# Its the first argument.
#
$atria_home = shift(@ARGV);
#
#  CVarious paths that may change for different platforms and installations.
#
if(exists($ENV{'TMP'})) {
    $MDEP_TMPDIR = $ENV{'TMP'};
} elsif (-d $ENV{'SystemDrive'}.'\tmp') {
    $MDEP_TMPDIR = $ENV{'SystemDrive'}.'\tmp';
} elsif (-d $ENV{'SystemDrive'}.'\temp') {
    $MDEP_TMPDIR = $ENV{'SystemDrive'}.'\temp';
} else {
    unless(mkdir($ENV{'SystemDrive'}.'\temp', 0777)) {
        printf "Could not find TMP ev or open \\temp on $ENV{'SystemDrive'}\n";
        exit 0;
    }
    $MDEP_TMPDIR = $ENV{'SystemDrive'}.'\temp';
}
# Now convert forward slashes that may have been picked up through mks.
# 
$MDEP_TMPDIR =~ s+/+\\+;

chdir("$atria_home");
$MDEP_ATRIA_DIR             = $atria_home;
$CLEARCASE_LIGHT = "";
$MDEP_VAR_ATRIA_DIR         = "var";
$MDEP_ATRIA_BIN_DIR         = "bin";
$MDEP_ATRIA_ETC_DIR         = "etc";
$MDEP_CLEARTOOL             = $MDEP_ATRIA_BIN_DIR.'\cleartool.exe';
$MDEP_ATRIA_LOG_DIR         = $MDEP_VAR_ATRIA_DIR.'\log';
$MDEP_ATRIA_CONF_DIR        = $MDEP_VAR_ATRIA_DIR.'\config';
$MDEP_STOP_CCASE            = 'net stop albd';
$MDEP_START_CCASE           = 'net start albd';
$MDEP_DBCHECK               = $MDEP_ATRIA_ETC_DIR.'\utils\dbcheck.exe -a';
$MDEP_IMSGLOG               = $MDEP_ATRIA_BIN_DIR.'\imsglog.exe';
$MDEP_LOG_FILE              = $MDEP_ATRIA_LOG_DIR.'\snap_log';
$MDEP_VOB_SERVER_CONF       = 'vob_server.conf';
$MDEP_VOB_SETUP             = $MDEP_ATRIA_ETC_DIR.'\vob_snapshot_setup';
$MDEP_MACHINE               = 'NT';
#
# Some needed commands
#
$MDEP_RMDIR_COMMAND         =  'cmd /c rmdir /s /q ';
$MDEP_RMFILE_COMMAND        =  'cmd /c del';
$MDEP_MOVE                  =  'cmd /c move ';
$MDEP_HOSTNAME_PROGRAM      =  'hostname';
$MDEP_TIME_STAMP            =  'cmd /c echo y | cmd /c time';
$MDEP_DATE_STAMP            =  'cmd /c echo y | cmd /c date';
$MDEP_GET_LOGIN             =  $MDEP_ATRIA_ETC_DIR.'\creds.exe';
$MDEP_ECHO                  =  'cmd /c echo';
$MDEP_COMMAND_FAILURE       =  'Command Failure';
$MDEP_CCASE_RUNNING      =  'net start';

#
# Some convenience definitions.
#
$MDEP_DESCRIBE              = "$MDEP_CLEARTOOL describe";
$MDEP_LSVOB                 = "$MDEP_CLEARTOOL lsvob";
$MDEP_GET_SNAP_ATTR         = 
    "$MDEP_DESCRIBE -aattr %s -fmt \"%%Na\" replica:%s@%s";
$MDEP_CHECKVOB              = "$MDEP_CLEARTOOL checkvob";
$MDEP_SUMMARY_COMMAND    =   
    "$MDEP_CHECKVOB %s -log %s -pool %s";
$MDEP_FIX_COMMAND  =     
    "$MDEP_CHECKVOB -fix %s -log %s -pool %s";
$MDEP_REPLACE_LOCK          = '-replace';
$MDEP_NO_REPLACE_LOCK       = "No Replace Lock";
$MDEP_DEFFERED_DEL_PARAMETER = 'DeferredSourceContainerDeletion';

#
# The one exception to the naming rule in this module. This is 
# the name of the snapshot parameter attribute that gets attached
# replicas that need to be snapped. The parameter, recover and snapshot
# scripts must see the same name so its here. Its description is 
# in vob_snapshot.pl. 
#
$SNAP_REP_PARAMETERS        =  "snapshot_vob_parameters";

#
# The string used to parse the parameters. The describe gets the attribute
# by name and formats it as "%Na".
# 
$SNAP_REP_PARAMETERS_PARSE  = 
       'snapshot_vob_parameters="dbcheck=(.*);snap_to=(.*);notify=(.*)$';




$MDEP_SEP                         = '\\';



@MDEP_DB_EXCLUDES                 = ("^\\.\$",
                                     "^\\.\\.\$",
                                     "^\\vista\\.taf\$",
                                     "^\\db_dumper\$");
         
@MDEP_MUST_HAVE                   = ('db\vob_db.dbd',
                                     'db\vob_db.d01',
                                     'db\vob_db.d02',
                                     'db\vob_db.d03',
                                     'db\vob_db.k01',
                                     'db\vob_db.k02',
                                     'db\vob_db.k03',
                                     'db\vob_db.k04',
				     'db\vob_db.str_file',
                                     'db\vob_db_schema_version');


$MDEP_YES_OR_NO                    = "yes,no";
$MDEP_YES_OR_NO_HELP               = "yes,no,help";
$MDEP_YES_NO_OR_QUIT               = "yes,no,quit";
$MDEP_YES_NO_QUIT_HELP             = "yes,no,quit,help";
$MDEP_YES_QUIT                     = "yes,quit";
$MDEP_YES                          = "yes";
$MDEP_QUIT                         = "quit";
$MDEP_YES_HELP                     = "yes,help";
$MDEP_YES_HELP_QUIT                = "yes,quit,help";
$MDEP_NO                           = "no";
$MDEP_NO_HELP                      = "no,help";
$MDEP_QUIT_RESPONSE                = "quit";
$MDEP_QUIT_HELP                    = "quit,help";
$MDEP_NL_RESPONSE                  = "";
$MDEP_HELP_RESPONSE                = "help";
$MDEP_RETURN_TO_CONTINUE           = "<RETURN> to continue";
$MDEP_QUIT_RETURN_TO_CONTINUE      = "quit,<RETURN> to continue";
$MDEP_ANY_RESPONSE                 = "any response allowed";
$MDEP_NO_HELP                      = "";
$MDEP_NO_DEFAULT                   = "";
$MDEP_FATAL = "FATAL";
$MDEP_ERROR = "ERROR";

$RTN_FILE_NULL                     = "File Name Is Null";
$RTN_FILE_NOT_EXIST                = "File Does Not Exist";
$RTN_FILE_OPEN_FAILED              = "File Open Failed";
$RTN_FILE_OPEN_OK                  = "File Open Ok";
$RTN_FILE_UNWRITABLE               = "File Not Writable";
$RTN_FILE_UNREADABLE               = "File Not Readable";
$RTN_FILE_NO_EXECUTE               = "File No Execute";
$RTN_FILE_IS_DIRECTORY             = "File Is Directory";
$RTN_DIR_NULL                      = "Directory Name Is Null";
$RTN_DIR_NOT_EXIST                 = "Directory Does Not Exist";
$RTN_DIR_OPEN_FAILED               = "Directory Open Failed";
$RTN_DIR_OPEN_OK                   = "Directory Open Ok";
$RTN_DIR_UNWRITABLE                = "Directory Not Writable";
$RTN_DIR_UNREADABLE                = "Directory Not Readable";
$RTN_DIR_NO_EXECUTE                = "Directory No Execute";
$RTN_DIR_NOT_DIRECTORY             = "Directory Not a Directory";
$RTN_DIR_IS_FILE                   = "Directory Is File";
$RTN_PDIR_NULL                     = "Parent Directory Is Null";
$RTN_PDIR_NOT_EXIST                = "Parent Directory does Not Exist";
$RTN_PDIR_OPEN_FAIED               = "Parent Directory Open Failed";
$RTN_PDIR_OPEN_OK                  = "Parent Directory Open Ok";
$RTN_PDIR_UNWRITABLE               = "Parent Directory Not Writable";
$RTN_PDIR_UNREADABLE               = "Parent Directory Not Readable";
$RTN_PDIR_NO_EXECUTE               = "Parent Directory No Execute";
$RTN_PDIR_NOT_DIRECTORY            = "Parent Directory Not a Directory";
$RTN_PATH_NULL                     = "Path Name Is Null";
$RTN_PATH_NOT_EXIST                = "Path Does Not Exist";
$RTN_PATH_OPEN_FAILED              = "Path Open Failed";
$RTN_PATH_OPEN_OK                  = "Path Open Ok";
$RTN_PATH_UNWRITABLE               = "Path Not Writable";
$RTN_PATH_UNREADABLE               = "Path Not Readable";
$RTN_PATH_NO_EXECUTE               = "Path No Execute";

$RTN_BAD_MODE                      = "Bad Mode";
$RTN_BAD_PATH                      = "Bad Path";
$RTN_GOOD_PATH                     = "Good Path";

$RTN_COPY_FAILED                   = "Copy Failed";
$RTN_COPY_OK                       = "Copy Ok";

$RTN_RENAME_FAILED                 = "Rename Failed";
$RTN_RENAME_OK                     = "Rename Ok";

$RTN_LOCK_FAILED                   = "Lock Operation Failed";
$RTN_LOCK_OK                       = "Lock Operation Ok";
$RTN_LOCK_WAS_LOCKED               = "Lock Was Locked";
$RTN_UNLOCK_FAILED                 = "Unlock Operation Failed";
$RTN_UNLOCK_OK                     = "Unlock Operation Ok";
$RTN_LOCK_WAS_UNLOCKED             = "Unlock Was Unlocked";

$RTN_REGISTER_FAILED               = "Register Failed";
$RTN_REGICTER_OK                   = "Register Ok";
$RTN_UNREGISTER_FAILED             = "Unregister Failed";
$RTN_NOT_REGISTERED                = "Not Registered";
$RTN_UNREGICTER_OK                 = "Unregister Ok";

$RTN_REPLICA_UUID_NULL             = "Replica Uuid Null";
$RTN_FAMILY_UUID_NULL              = "Family Uuid Null";

$RTN_VOB_TAG__NULL                 = "Vob Tag Is Null";
$RTN_RMTAG_OK                      = "Rmtag Operation Ok";
$RTN_NO_TAG                        = "No Tag";
$RTN_MKTAG_FAILED                  = "Mktag Operation Failed";

$RTN_VOB_INFO_INCONSISTENT         = "Vob Info Inconsistent";

$RTN_CCASE_START_FAILED            = "Clearcase Start Failed";
$RTN_CCASE_START_OK                = "Clearcase Start Ok";
$RTN_CCASE_STOPFAILED              = "Clearcase Stop Failed";
$RTN_CCASE_STOP_OK                 = "Clearcase Stop Ok";

$RTN_MOUNT_FAILED                  = "Mount Failed";
$RTN_MOUNT_OK                      = "Mount Ok";
$RTN_UMOUNT_FAILED                 = "Umount Failed";
$RTN_UMOUNT_OK                     = "Umount Ok";

$RTN_INVALID_TAG                   = "Invalid Tag";
$RTN_VALID_TAG                     = "Valid Tag";

$RTN_DB_PROTECTED                  = "Db Protected";
$RTN_DB_UNPROTECTED                = "Db Unprotected";

$RTN_DBCHECK_FAILED                = "Dbcheck Failed";
$RTN_DBCHECK_OK                    = "Dbcheck Ok";

$RTN_BAD_PARAMETERS                = "Bad Parameters";

$RTN_NOT_OK                        = "All Not Ok";
$RTN_OK                            = "All Ok";
$RTN_SET                           = "Is set";
$RTN_NOT_SET                       = "Is Not Set";
$RTN_NO_STATUS_SET                 = "No Return Status Set";

$RTN_EQUAL                         = "Are Equal";
$RTN_NOT_EQUAL                     = "Are Not Equal";


$RTN_FALSE                         = 0;
$RTN_TRUE                          = 1;

$MDEP_ERROR_STR                    = "ERROR   ";
$MDEP_FATAL_STR                    = "FATAL   ";
$MDEP_WARN_STR                     = "WARNING ";
$MDEP_NOTE_STR                     = "NOTE    ";
$MDEP_UNKNOWN_STR                  = "Unknown Error Type";

#
# Error handling constants
# Used to construct the error routing tokens below. 
#
$MDEP_ERROR                   = 0x0010;      # Non fatal error
$MDEP_FATAL                   = 0x0020;      # Fatal error
$MDEP_WARN                    = 0x0040;      # Just a warning
$MDEP_NOTE                    = 0x0080;      # Only a note
$MDEP_NOTIFY                  = 0x0001;      # Send notification only
$MDEP_LOG                     = 0x0002;      # Write out the log only
$MDEP_BOTH                    = 0x0003;      # Mail it and log it

#
# What kind of message is being logged. One is passed as a first
# argument to &mdep_logger. 
#
$MDEP_E_N                     = $MDEP_ERROR | $MDEP_NOTIFY;
$MDEP_E_L                     = $MDEP_ERROR | $MDEP_LOG;   
$MDEP_E_B                     = $MDEP_ERROR | $MDEP_BOTH;
$MDEP_F_N                     = $MDEP_FATAL | $MDEP_NOTIFY;
$MDEP_F_L                     = $MDEP_FATAL | $MDEP_LOG;
$MDEP_F_B                     = $MDEP_FATAL | $MDEP_BOTH;
$MDEP_W_N                     = $MDEP_WARN  | $MDEP_NOTIFY;
$MDEP_W_L                     = $MDEP_WARN  | $MDEP_LOG;
$MDEP_W_B                     = $MDEP_WARN  | $MDEP_BOTH;
$MDEP_N_N                     = $MDEP_NOTE  | $MDEP_NOTIFY;
$MDEP_N_L                     = $MDEP_NOTE  | $MDEP_LOG;
$MDEP_N_B                     = $MDEP_NOTE  | $MDEP_BOTH;

sub system_redirect {

    local($command) = @_[0];
    local($ret_status);
    local($tmpname);

    $tmpname = &mdep_get_tmpname();
    $ret_status = system("$command > $tmpname 2>&1");

    #
    # Don't call mdep_rmfile - it calls system_redirect. 
    #
    system("$MDEP_RMFILE_COMMAND $tmpname");
    return $ret_status;

}
 

#
# mdep_internal_error_str()
# Inputs:
#   $module
#     The name of the calling program.
#   $identifier
#     The error identifier. Should be of the form "###". If a new internal 
#     error is found add another number to the list contained in the
#     the calling module. The ones in use should be listed in the callers
#     module and should be of the form MODULE_INTERNAL_ERROR_###. As an
#     example, the vob recover script contains....
#        $RECOVER_INTERNAL_ERROR_001 = "001;
#        $RECOVER_INTERNAL_ERROR_002 = "002;
#        $RECOVER_INTERNAL_ERROR_003 = "003;
#        $RECOVER_INTERNAL_ERROR_004 = "004;
#                         .
#                         .
#                         .
#     The idea is to be able to grep the module for the the appropriate
#     MODULE_INTERNAL_ERROR_### sting given a '###' from support. 
#   $release
#     The format preceeds the the identifier with this field. In case
#     the meaning of the $identifier changes from one release to another
#     this will maintain uniquness. As an example, the vob_recover script
#     cotained the definition
#        $RECOVER_RELEASE = "R3.0B1";
#     for the first beta release of 3.0 and similary will contain.
#        $RECOVER_RELEASE = "R3.0";
#     for the 3.0 release. The definition is arbitrary but different
#     for different releases of the calling module.
#   $error
#     The error string. 
# Outputs:
#   None
# Returns:
#   None
# References:
#   None
# Modifies:
#   None
# Calls:
#   &mdep_error()
# Description:
#   The idea is to uniquely identify internal errors across various 
#   translations of the error strings themselves. The definitions of
#   $identifier and $release desribed above should probably be preceeded
#   by a not to the translator to not translate them. In this way support
#   can always ask for the identifier and a grep of the appropriate release
#   for the module can be done. None internal errors messages shouldn't
#   require a call to support to resolve. 
sub mdep_internal_error_str {

    local($identifier) = @_[0];     # The error identifier
    local($release) = @_[1];        # The release string
    local($error) = @_[2];          # The error string
    local($fstr) = "";              # Format string buffer

    $MDEP_INTERNAL_CONSISTENCY_STR  = 
"An internal consistency failure [%s.%s] has occurred
Contact your support representative with the information contained in this 
message.
%s\n";

    $fstr = sprintf($MDEP_INTERNAL_CONSISTENCY_STR,$release,
		    $identifier,$error);
    
    return $fstr;

}


#
# mdep_prompt()
# Inputs: 
#   $arg_prompt
#     The prompt string to emit.
#   $arg_options
#     The accepted responses - a single string containing comma seperated
#     list. 
#   $arg_default
#     The default. It must be either null or one of the responses in 
#     $options.
#   $arghelp
#     Help string if available, null if not.
# Outputs:
#   None
# Returns
#   One of the accepted responses.
# References:
#   None
# Modifies:
#   None
# Calls:
#   &mdep_error()
# Description:
#   A formatted prompt is sent to the user and a response is read. The 
#   optional responses and default, if there is one, are formatted 
#   with the $prompt argument. The formatted prompt informs the user 
#   whether or not there is a default. If the response obtained is not 
#   a valid one, another is requested. There is no default if $default 
#   is null. In this case resposes are requested until a valid one is 
#   gotten. The special $options string $MDEP_ANY_RESPONSE indicates 
#   that any response is allowed. Just return the string the user types. 
#   If $help is set one of the allowed responses should be 
#   $MDEP_HELP_RESPONSE. If this response is seen the help string is 
#   put out, a wait is done for any key from the user, and the $prompt 
#   is sent again. If help is intended for the $MDEP_ANY_RESPONSE, 
#   case the help option should be included in the prompt string itself,
#   and $help should contain a help string. Use $MDEP_HELP_RESPONSE for 
#   string to specify its availability. 
#
sub mdep_prompt {

    local($arg_prompt) = @_[0];    # The prompt sring
    local($arg_options) = @_[1];   # The optional responses
    local($arg_default) = @_[2];   # The default
    local($arg_help) = @_[3];      # The help string
    local(@options);               # The options in reasonable form
    local($option);                # Single option holder.
    local($fstr) = "";             # The format string
    local($reply) = "";            # Local reply holder
    local($is_default) = 0;        # Set if there is a default
    local($help_available) = 0;    # Set if help is available
    local($any_allowed) = 0;       # Set if any response is allowed

    $MDEP_P_FORMAT_WITH_DEFAULT =
"%s
Valid responses are (%s) 
The default is %s: ";

    $MDEP_P_FORMAT_WITHOUT_DEFAULT =
"%s
Valid responses are (%s) 
There is no default response: ";

    $MDEP_FORMAT_ANY_RESPONSE_ALLOWED = "%s";
    #
    # Check for anything allowed. Its a simple string token so
    # no need to do the split if its set.
    #
    if($arg_options eq $MDEP_ANY_RESPONSE) {

	$any_allowed = 1;
	#
	# Any can't specify help so rely on the help string itself to
        # indicate its availability.
	#
	if($arg_help ne "") {

	    $help_available = 1;

	}
    }
    else {

	#
	# Put the options in a reasonable form.
	#
	@options = split(',',$arg_options);
	# 
	# See if help is available
	#
	foreach $option (@options) {

	    if($option eq $MDEP_HELP_RESPONSE) {

		if($arg_help ne "") {

		    $help_available = 1;
		    last;
		}
	    }
	}
    }

    #
    # Format the prompt string.
    #
    if($arg_options eq $MDEP_ANY_RESPONSE) {

	$fstr = $arg_prompt;
    }
    elsif($arg_default ne "") {

	# 
        # A default was given. Set $answer to the default and do format
        # to give default to the user.
        #
	$fstr = sprintf($MDEP_P_FORMAT_WITH_DEFAULT,
			$arg_prompt,$arg_options,$arg_default);
    }
    else {

        #
        # No default was given. Format to tell user there is no default
        # response.
        #
	$fstr = sprintf($MDEP_P_FORMAT_WITHOUT_DEFAULT,
			$arg_prompt,$arg_options);
    }

    if($arg_default) {

	$is_default = 1;
    }

ASK_AGAIN:
    while (1) {

	print "\n$fstr";
	$reply = <STDIN>;
        chop $reply;

	#
	# Check for the help string up front if its available
	#
	if(lc($reply) eq lc($MDEP_HELP_RESPONSE)) {
	    if($help_available) {

		print "\n$arg_help";
		print "\nPress <RETURN> to return to the prompt.....";
		#
		# Wait for any key. This response gets dropped.
		#
		$reply = <STDIN>;
		next ASK_AGAIN;
	    }
	    else {
		print 
"\nNo help is available for this prompt. 
Press <RETURN> to continue.....\n";
		$reply = <STDIN>;
		next ASK_AGAIN;
	    }
	}
	
	#
        # If the user just hit return and there is a default return the
        # default answer.
        #
	if($reply eq $MDEP_NL_RESPONSE) {

	    if($is_default) {

		return $arg_default;
	    }
	    else {

		if($any_allowed) {

		    return $reply;
		}

		foreach $option (@options) {

		    if($option eq $MDEP_RETURN_TO_CONTINUE) {
			return $reply;
		    }
		}
		
		next ASK_AGAIN;
	    }
	}

	#
	# If anything else is allowed return it.
	#
	if($any_allowed) {

	    return $reply;
	}

	#
	# See if its another valid response
	#
	foreach $option (@options) {
            
	    if(lc($reply) eq lc($option)) {

		return $reply;
	    }
	}
    }
}




sub mdep_error {
	
    local($program_name) = @_[0];
    local($function) = @_[1];
    local($level) = @_[2];
    local($message) = @_[3];
    

    print "\n\nError: $program_name encountered an error in $function:\n$message";
    if( $level eq "FATAL" ) {exit();}
    
}

sub mdep_get_tmpname {
    
    $vob_recover_tmpseq++;
    return "${MDEP_TMPDIR}\\vob_snapshot_tmp.$$.${vob_recover_tmpseq}";
    
}

sub mdep_command {
    local($command) = @_[0];
    local($tmpname);
    local($status);
    local(@cmdbuf);
    local($line);
    local(@args);
 
 
    $command = @_[0];
    if($command eq "") {
        @cmdbuf[0] = $MDEP_COMMAND_FAILURE;
        return @cmdbuf;
    }
#    print "JD: cmd1 $command\n";
    @args = split(' ',$command);
 
    $tmpname = &mdep_get_tmpname();
    $status = system("$command > $tmpname 2>&1");
 
    if($status != 0) {
	open(tfh,$tmpname);
	while(<tfh>) {
	    print "command error: $_\n";
	}
	close(tfh);
        &mdep_rmfile($tmpname);
        @cmdbuf[0] = "Command Failure";
        return @cmdbuf;
    }
 
    #
    # Read lines of output untill there are no more. Push each line
    # onto the return array.
 
    open(NODROP_COMMAND_BUF,$tmpname);
    foreach $line (<NODROP_COMMAND_BUF>) {
        push(@cmdbuf,$line);
    }
    close(NODROP_COMMAND_BUF);
    &mdep_rmfile($tmpname);
    return @cmdbuf;
 
}

sub mdep_command_s {
    
    local(*command,*cmdbuf) = @_;
    local($tmpname);
    local($status);
    local($line);
    local(@args);
    
    if($command eq "") {
	return 1;
    }
    @args = split(' ',$command);
    
    $tmpname = &mdep_get_tmpname();
#    print "JD: cmd2: $command\n";
    if($command =~ /(.*)(\\"dbcheck.*notify=\\")(.*)/) {
	$command = $1.'"'.$2.'"'.$3;
    }

    $status = system("$command > $tmpname 2>&1");
    
    #
    # Read lines of output untill there are no more. Push each line
    # onto the return array.

    open(NODROP_COMMAND_BUF,$tmpname);
    foreach $line (<NODROP_COMMAND_BUF>) {
	push(@cmdbuf,$line);
    }
    close(NODROP_COMMAND_BUF);
    &mdep_rmfile($tmpname);

    return $status;

} 
  
sub mdep_get_time {
    
    local($tmpname);
    local($line);
    local($date);
    local($time);
    local($r_string) = "";
    $tmpname = &mdep_get_tmpname();
    system("$MDEP_DATE_STAMP > $tmpname");
    open(GETDATE,$tmpname);
    foreach $line (<GETDATE>) {
	chop $line;

        # this change fixes getting the date on non-English PCs,
        # since on those systems the beginning of the 'date' line
        # might not be "The current date is:".
        # First, we get the whole date (possibly starting with the
        # day of the week as in English system: Sun, Mon etc.)
	if($line =~ /.+:\s+(.*)/) {
            $line = $1;
            
            if ($line =~ /[a-zA-Z]+\s+(.*)/){
                # below, if the date starts with the day of the week, 
                # we get rid of it, for backward compatibility
                # (some of the client's script might have been 
                # using the fact that the date did not include 
                # the day of the week).
                $date = $1;
            }
            else {
                # If the date does not start with a day of the week
                # as, e.g. on a German PC, we just set the date to
                # be the full returned date.
                $date = $line;
            }
        }
        last;
    }
    close(GETDATE);
    system("$MDEP_TIME_STAMP > $tmpname");
    open(GETTIME,$tmpname);
    foreach $line (<GETTIME>) {
	chop $line;
        # this change fixes getting the time on non-english PCs,
        # since on those systems the beginning of the 'time' line
        # might not be "The current time is:".
	if($line =~ /.+:\s+(.*)/) {$time = $1; last}
    }
    close(GETTIME); 
    
    &mdep_rmfile($tmpname);
    $r_string = "$date $time";
    return($r_string);

}


sub mdep_dirname {

    local($path) = @_[0];      # Path
    local($lslash);            # Index to the last slash in $path
    local($colon);
    local($dirname);


    #
    # Check for a null input first.
    if($path eq "") {

	return $RTN_PATH_NULL;

    }

    $colon = index($path,':');
    $lslash = rindex($path,'\\');
    if($lslash == -1) {

        if($colon >= 0) {

	    #
            # Treat c: as invalid
            #
            return $RTN_INVALID_PATH;
        }

	# 
	# Parent of foo is .
	#
	return '.';

    }
    else {

	#
	# Pick it out
	#
	$dirname = substr($path,0,$lslash);
        if($colon >= 0) {

            if($colon == length($path)-1) {

                #
                # c:\ has no parent
                #
	        return $RTN_INVALID_PATH;
            }
        
            if($colon == length($dirname) - 1) {

                #
                # c:\foo returns c:\
                #
                $dirname = $dirname.'\\';
            }
        }

        return $dirname;
   }
}

sub mdep_basename {

    local($Path) = @_[0];      # Path
    local($lslash);            # Index to the last slash in $path
    local($basen);
    local($colon);


    #
    # Check for a null input first.
    $path = $Path;
    if($path eq "") {

	return $RTN_PATH_NULL;

    }
    $path =~ s/\///g;
    $colon = index($path,':');
    $lslash = rindex($path,'\\');

    if($lslash == -1) {

	if(($colon >= 0) &&
          ($colon == (length($path) - 1))) {

            # 
            # Looks like a c: type. Bad.
	    #
	    return $RTN_INVALID_PATH;
	}

	# 
	# No slashes. Must be in the current working directory.
	#
        $basen = $path;

    }
    else {
        if(($colon >= 0) && 
	   ($colon == (length($path) - 2))) {
     
            #
	    # The path was a c:\
            # Return same.
	    return $path;
         }
	 #
	 # Pick it out
	 #
	 $basen = substr($path,$lslash + 1);
         return $basen;
    }
   
}
    
#
# Does this realy have to use mdep_command or should it use
# the cmd /c syntax.
#
sub mdep_get_hostname {

    local(@cmdbuf);
    local($hostname) = "";
    
    @cmdbuf = 
	&mdep_command("$MDEP_HOSTNAME_PROGRAM");
    
    if(@cmdbuf[0] eq $MDEP_COMMAND_FAILURE) {
	
	$hostname = "";
    }
    
    $hostname = @cmdbuf[0];
    chop $hostname;
    return($hostname);

}


sub mdep_dodbcheck {

    local($storage) = @_[0];
    local($dbdir);
    local($dbname);

    
    $dbdir = $storage.$MDEP_SEP.'db';
    $dbname = $dbdir.$MDEP_SEP.'vob_db';
    #
    # JD_TODO This is no good. It could fill the disk. Where
    # is the bit bucket on NT.
    #
    if(&system_redirect("$MDEP_DBCHECK \"$dbname\"")) {

	return  $RTN_DBCHECK_FAILED;
    }
    
    &mdep_rmfile($tmpname);

    return $RTN_DBCHECK_OK;

}

sub mdep_is_clearcase_up {

    local(@cmdbuf); 
    local($command);
    local($status);

    $command = $MDEP_CCASE_RUNNING;
    $status = &mdep_command_s(*command,*cmdbuf);
    if($status) {

	return -1;
    }
    if(grep(/Atria Location Broker/,@cmdbuf)) {

	return 1;
    }
    else {

	return 0;
    }
}
	
sub mdep_stop_clearcase {

    local($status);        # Return status
    local($tmpname);
    local($line);

    $tmpname = &mdep_get_tmpname();
    $status = system("$MDEP_STOP_CCASE > $tmpname 2>&1");

    if($status) {

	#
	# If the failure was a umount problem ignore it.
	#
	unless(open(TMPFILE,$tmpfile)) {
            &mdep_rmfile($tmpname);
	    return $RTN_CCASE_STOP_FAILED;
	}

	foreach $line (<TMPFILE>) {

	    if($line =~ /Refer to the log.*mntrpc_server_log/) {
                &mdep_rmfile($tmpname);
		return $RTN_CCASE_STOP_OK;
	    }
	}
	close(TMPFILE);
	&mdep_rmfile($tmpname);
	return $RTN_CCASE_STOP_FAILED;
    }
    &mdep_rmfile($tmpname);
    return $RTN_CCASE_STOP_OK;
}  



sub mdep_start_clearcase {

    local($status);        # Return status
    local($tmpname);
    local($line);
    local($ret_status);

CLEANUP_START_CLEARCASE: {

    $tmpname = &mdep_get_tmpname();
    $status = system("$MDEP_START_CCASE > $tmpname 2>&1");

    if($status) {

	#
	# If the failure was a umount problem ignore it.
	#
	unless(open(TMPFILE,$tmpname)) {

	    $ret_status = $RTN_CCASE_START_FAILED;
	}

	foreach $line (<TMPFILE>) {

	    if($line =~ /Refer to the log.*mntrpc_server_log/) {
                
		$ret_status =  $RTN_CCASE_START_OK;
                last CLEANUP_START_CLEARCASE;
	    }
	}

	$ret_status =  $RTN_CCASE_START_FAILED;
    }

    $ret_status = $RTN_CCASE_START_OK;

} CLEANUP_START_CLEARCASE:

    close(TMPFILE);
    &mdep_rmfile($tmpname);
    return $ret_status;
}  



sub mdep_mk_attribute_string {

    local($dbcheck) = @_[0];
    local($snap_to) = @_[1];
    local($notify) = @_[2];
    local($snap_to_cvt);
    local($notify_cvt);
    local($attr);
    
    ($snap_to_cvt = $snap_to) =~ s/\\/\\\\/g;
    ($notify_cvt = $notify) =~ s/\\/\\\\/g;
             $attr = "dbcheck=${dbcheck};snap_to=${snap_to_cvt};notify=${notify_cvt}";
    return($attr);
}



sub mdep_rmfile {

    local($file) = @_[0];
    local($status);
    
    if($file eq "") {
	return $RTN_PATH_NULL;
    }
    
    $status = &system_redirect("$MDEP_RMFILE_COMMAND \"$file\"");
    
    if($status) {
	
	return $RTN_NOT_OK;
    }
    
    return $RTN_OK;
}



sub mdep_get_local_tags {

    local(*host,*tags) = @_;
    local($line);
    local($tag);
    my($h);
    my $ipaddr = gethostbyname($host);
    if (!$ipaddr) {
        return $RTN_NOT_OK;
    }
    my $ipaddr_tag;
    local(@lcmdbuf);

    # set following env. for tagged massage output
    # for lsvob -l command
    $ENV{'CLEARCASE_ENABLE_ATE_MESSAGES'} = "TRUE";

    @lcmdbuf = &mdep_command("$MDEP_CLEARTOOL lsvob -long");

    if(exists($ENV{'CLEARCASE_ENABLE_ATE_MESSAGES'})) {
        delete $ENV{"CLEARCASE_ENABLE_ATE_MESSAGES"};
    }

    if(@lcmdbuf[0] eq $MDEP_COMMAND_FAILURE) {
        return $RTN_NOT_OK;
    }

    #parsing tagged message output to get all local vob tags
    my $i = 0;
    foreach (@lcmdbuf) {
        local @fields = ();
	local $tmpstore;


        #lsvob output using the message of 686 in cmd.m for vob tag
        #search for TAG_ID:cmd!!*!!686:END_ID to get vob tag
	if(/^TAG_ID:cmd!!\d+!!686:END_ID/) {
            @fields = split(":", $lcmdbuf[$i+2]);
            $tag = $fields[1];
	} elsif(/^TAG_ID:cmd!!\d+!!704:END_ID/) {
	    @fields = split(":", $lcmdbuf[$i+2]);
            $tmpstore = $fields[1];
            @fields = split("!!", $tmpstore);
	    $tag = $fields[0];
	} elsif(/^TAG_ID:cmd!!\d+!!695:END_ID/) {
            @fields = split(":", $lcmdbuf[$i+2]);
            # now compare IP instead of hostname
            $h = $fields[1];
            $ipaddr_tag = gethostbyname($h);
            if($ipaddr_tag eq $ipaddr) {
		$tag .= "\n";
		push(@tags,$tag);
            }
	}
        $i++;
    }
    return $RTN_OK;

}

sub mdep_rmdir {

    local($dirpath) = @_[0];
    local($status);   
    if($dirpath eq "") {
	print "null directory\n";
	return(-1);
    }
    
    if(! -d $dirpath) {
	print "directory $dirpath doesn't exist\n";
	return(-1);
    }
     
    $status = &system_redirect("$MDEP_RMDIR_COMMAND \"$dirpath\"");
    
    return($status);
}


#
# JD_FIX what should it skip on NT
#
sub mdep_skip_directory {

    local($dir) = @_[0];     # The directory to check.

    if(($dir eq '.') ||
       ($dir eq '..')) {
	
	return $RTN_TRUE;

    }

    return $RTN_FALSE;
}



sub mdep_nt {

    return 1;
}

sub mdep_uncname {

    local($host) = shift(@_);
    local($path) = @_;
    local($uncname);
    
    $path =~ s/:\\/\\/;
    $uncname =  '\\\\'.$host.'\\'.$path;
    return $uncname;
    
}  

sub mdep_unregister_vob_object {

    local($replica_uuid) = @_[0];       # Vob replica uuid
    local($status);                     # Return status
    local(@cmdbuf);                     # Return buffer for mdep_command
    local($line);                       # Line buffer for parsing
    local($ret_status);                 # Return status
  
CLEANUP_UNREGISTER_VOB_OBJECT: { # Always return at end of this block.

    if($replica_uuid eq "") {

	$ret_status = $RTN_REPLICA_UUID_NULL;
	last CLEANUP_UNREGISTER_VOB_OBJECT;
    }

    @cmdbuf = &mdep_command(
		    "$MDEP_CLEARTOOL unregister -vob -uuid $replica_uuid");

    if(@cmdbuf eq $MDEP_COMMAND_FAILURE) {
	
	#
	# See if it failed because it was already unregistered.
	#
	foreach $line (@cmdbuf) {

	    if($line =~ /Unable to find a registry entry for VOB/) {

		$ret_status = $RTN_NOT_REGISTERED;
		last CLEANUP_UNREGISTER_VOB_OBJECT;
	    }
	}

	$ret_status =  $RTN_UNREGISTER_FAILED;
	last CLEANUP_UNREGISTER_VOB_OBJECT;
    }

    $ret_status =  $RTN_UNREGISTER_OK;

  } # CLEANUP_UNREGISTER_VOB_OBJECT Always return here

    return $ret_status;
}

sub mdep_register_vob_object {

    local($storage) = @_[0];       # Vob storage area
    local($status);                # Return status
    local($host);
  
    if($storage eq "") {

	return $RTN_PATH_NULL;

    }
    if(!$CLEARCASE_LIGHT) {
        if(!&mdep_is_uncname($storage)) {
            $host = &mdep_get_hostname();
  	    $storage = &mdep_uncname($host,$storage);
        }
    }
    $status = &system_redirect("$MDEP_CLEARTOOL register -vob \"$storage\"");
    if($status) {

	return $RTN_REGISTER_FAILED;

    }
    return $RTN_REGISTER_OK;
    
}

sub mdep_rmtag {

    local($vobtag) = @_[0];       # Vob tag
    local($status);               # Return status
    local(@cmdbuf);               # Return buffer for mdep_command
    local($line);                 # Line buffer for parsing
    local($ret_status);           # Return status

  
CLEANUP_RMTAG: { # Always return at end of this block.

    if($vobtag eq "") {

	$ret_status = $RTN_VOB_TAG_NULL;
	last CLEANUP_RMTAG;
    }

    @cmdbuf = &mdep_command("$MDEP_CLEARTOOL rmtag -vob $vobtag");
    
    if(@cmdbuf eq $MDEP_COMMAND_FAILURE) {

	#
	# See if it failed because the tag doesn;t exist
	#
	foreach $line (@cmdbuf) {

	    if($line =~ /is not a registered vob tag/) {

		$ret_status = $RTN_NO_TAG;
		last CLEANUP_RMTAG;
	    }
	}


	$ret_status =  $RTN_RMTAG_FAILED;
	last CLEANUP_RMTAG;

    }

    $ret_status = $RTN_RMTAG_OK;

  } # CLEANUP_RMTAG Always return here

    return $ret_status;
}


sub mdep_mktag {

    local($vobtag) = @_[0];       # Vob tag
    local($spath) = @_[1];        # Vob storage path
    local($status);               # Return status
    local($host);
    if(!$CLEARCASE_LIGHT) {
        if(!&mdep_is_uncname($spath)) {
            $host = &mdep_get_hostname();
	    $spath = &mdep_uncname($host,$spath);
        }
    }
    if($vobtag eq "") {

	return $RTN_VOB_TAG_NULL;

    }

    if($spath eq "") {

	return $RTN_PATH_NULL;

    }
    print "$MDEP_CLEARTOOL mktag  -vob -tag $vobtag $spath\n";
    $status = &system_redirect("$MDEP_CLEARTOOL mktag  -vob -tag $vobtag \"$spath\"");
    if($status) {

	return $RTN_MKTAG_FAILED;

    }

    return $RTN_MKTAG_OK;
}


# 
# mdep_copy_file 
# Inputs:
#   $source 
#     The path of the source file
#   $target
#     THe target file path or a target directory to get $source.
# Outouts:
#   None
# Returns:
#   None
# References:
#   None
# Modifies:
#   None
# Calls:
#   None
# Description:
#   If $target is a file name copy $source to $target. If $target is a 
#   directory copy $source into $target.
#
sub mdep_copy_file {

    local($spath) = @_[0];        # Source path
    local($tpath) = @_[1];        # Destination path
    local($ddir);                 # Destination directory
    local($sdir);                 # Source directory 
    local($sfile);                # Source basename
    local($tisfile);              # Destination a regular file
    local($tmpname);              # For redirected output
    local($ret_status);           # Return status

CLEANUP_COPY_FILE: {


    #
    # Check for null paths
    #
    if($spath eq "") {

	$ret_status = $RTN_PATH_NULL;
        last CLEANUP_COPY_FILE;
  

    }
    if($tpath eq "") {

	$ret_status = $RTN_PATH_NULL;
        last CLEANUP_COPY_FILE;

    }


    #
    # If the source is a directory the wrong function was called.
    # This one only does regular files.
    #
    if(-d $spath) {

	$ret_status = $RTN_FILE_IS_DIRECTORY;
        last CLEANUP_COPY_FILE;

    }

    #
    # See if $target is a directory or regular file.
    #
    if(-d $tpath) {

	# 
	# In this case the destination directory realy is $target. Set
	# the destination basename to null.
        #
	$ddir = $tpath;
        $tisfile = 0;
    }
    else {

	#
	# $target is the pathname for a regular file. The target 
        # directory will be the directory to contain this regular file.
	#
	$ddir = &mdep_dirname($tpath);
	if(($ddir eq $RTN_PATH_NULL) ||
           ($ddir eq $RTN_INVALID_PATH)) {

	    $ret_status = $ddir;
            last CLEANUP_COPY_FILE;

	}
      
        $tisfile = 1;

    }

    #	
    # Get the directory and basename for the source.
    # 
    $sdir = &mdep_dirname($spath);
    if(($sdir eq $RTN_PATH_NULL) ||
       ($sdir eq $RTN_INVALID_PATH)) {

	    $ret_status = $sdir;
            last CLEANUP_COPY_FILE;

    }
    
    #
    # Check for read and write on the source directory. Just write on the
    # target. 
    #
    if(! -r $sdir) {

	$ret_status = $RTN_DIR_UNREADABLE;
        last CLEANUP;

    }

    #
    # Check to see if the destination directory exists
    #
    if(! -d $ddir) {

	$ret_status = $RTN_DIR_NOT_EXIST;
        last CLEANUP_COPY_FILE;

    }
    if(! -w $ddir) {

	$ret_status = $RTN_DIR_UNWRITABLE;
        last CLEANUP_COPY_FILE;

    }

    #
    # See if the source exists
    #
    if(! -e $spath) {

	$ret_status = $RTN_FILE_NOT_EXIST;
        last CLEANUP_COPY_FILE;

    }

    #
    # Now check read on source file.
    # 
    if(! -r $spath) {

	$ret_status = $RTN_FILE_UNREADABLE;
        last CLEANUP_COPY_FILE;

    }

    #
    # Ok. So see if the copy works. mdep_copy_file uses tar so 
    # send it everything it needs.
    #
    if($tisfile == 0) {

        #
        # The target is a directory
        #
        if(&system_redirect("xcopy \"$spath\" \"$tpath\"")) {

	    $ret_status = $RTN_COPY_FAILED;
            last CLEANUP_COPY_FILE;
        }
    }
    else {

        #
        # Its a regular file
        #
        if(&system_redirect("$MDEP_ECHO F | xcopy \"$spath\" \"$tpath\"")) {

	    $ret_status = $RTN_COPY_FAILED;
            last CLEANUP_COPY_FILE;
        }
    }
    
    $ret_status = $RTN_COPY_OK;

  } # CLEANUP_COPY_FILE

  return $ret_status;
    
}

#
# mdep_copy_directory
# Inputs: 
#   spath
#     The source path to copy.
#   tpath
#     The target path to contain the copy.
# Ouputs:
#   None
# Returns
#   None
# References:
# Modifies:
# Calls:
# Description:
#   Recursivly copy $source into the $target directory.
sub mdep_copy_directory {

    local($spath) = @_[0];     # Source directory path
    local($tpath) = @_[1];     # Target directory path
    local($sname);             # Name of the source directory
    local($xdest);             # Path of destination with name
    local($ret_status);           # Return status

CLEANUP_COPY_DIRECTORY: {
    
    #
    # Check the arguments.
    #
    if($spath eq "") {

	$ret_status = $RTN_PATH_NULL;
        last CLEANUP_COPY_DIRECTORY;

    }
    if($tpath eq "") {

	$ret_status = $RTN_PATH_NULL;
        last CLEANUP_COPY_DIRECTORY;
    
    }
    
    #
    # Make sure they are both directories
    # 
    if(! -d $spath) {

	$ret_status = $RTN_DIR_NOT_DIRECTORY;
        last CLEANUP_COPY_DIRECTORY;
    }

    if(! -d $tpath) {

	$ret_status = $RTN_DIR_NOT_DIRECTORY;
        last CLEANUP_COPY_DIRECTORY;

    }
    #
    # Check permissions
    #
    if(! -r $spath) {

	$ret_status = $RTN_DIR_UNREADABLE;
        last CLEANUP_COPY_DIRECTORY;

    }

    if(! -w $tpath) {

	$ret_status = $RTN_DIR_UNWRITABLE;
        last CLEANUP_COPY_DIRECTORY;

    }

    #
    # xcopy need the name of the directory on the target
    # as well as the source
    #
    $sname = &mdep_basename($spath);
    if(($sname eq $RTN_PATH_NULL) ||
       ($sname eq $RTN_INVALID_PATH)) {

        $ret_status = $sname;
        last CLEANUP_COPY_DIRECTORY;
    }

    $xdest = $tpath.$MDEP_SEP.$sname;
    if(&system_redirect("xcopy /e /s /k /i  \"$spath\" \"$xdest\"")) {

	$ret_status = $RTN_COPY_FAILED;
        last CLEANUP_COPY_DIRECTORY;

    }

    $ret_status = $RTN_COPY_OK;

  } # CLEANUP_COPY_DIRECTORY

    return($ret_status);

}


# mdep_log_copy_error
#
sub mdep_log_copy_error {

    local($xcopyout) = @_;
    local(@xcopyerror);
    local($line);

    &mdep_logger($MDEP_E_L, "xcopy failed. Its output follows...\n");
    unless(open(XCOPYOUT, "$xcopyout")) {
        &mdep_logger($MDEP_E_L, sprintf("  FAILED to open errorlog: \"%s\"\n", $xcopyout));
        return;
    }
    @xcopyerror = <XCOPYOUT>;
    while($line = shift(@xcopyerror)) {
        &mdep_logger($MDEP_E_L, $line);
    }
    close(XCOPYOUT);
}


#
# mdep_copy_list
# Inputs: 
#   sdir
#     The directory path that contains the list of files/directories
#   tdir
#     The directory path to copy them to.
#   list 
#     The list of files directories to copy.
# Ouputs:
#   None
# Returns
#   None
# References:
# Modifies:
# Calls:
# Description:
#   Copy all of the files and directories in $list from the $src directory
#   to the $dest directory
#
sub mdep_copy_list {

    local($spath) = shift(@_);          # Source directory path
    local($tpath) = shift(@_);          # Target directory path
    local(@list) = @_;                  # List to copy
    local($ret_status);                 # Return status
    local($xcopyout);
    local(@xcopyerror);
    local($line);
    local($sys_status);

CLEANUP_COPY_LIST: {
    #
    # Check the arguments
    #
    if($spath eq "") {

	$ret_status =  $RTN_PATH_NULL;
        last CLEANUP_COPY_LIST;

    }
    if($tpath eq "") {

	$ret_status =  $RTN_PATH_NULL;
        last CLEANUP_COPY_LIST;

    }

    #
    # Make sure $sdir and $tdir are directories
    #
    if(! -d $spath) {

	$ret_status =  $RTN_DIR_NOT_DIRECTORY;
        last CLEANUP_COPY_LIST;

    }

    if(! -d $tpath) {

	$ret_status =   $RTN_DIR_NOT_DIRECTORY;
        last CLEANUP_COPY_LIST;

    }

    #
    # Check permissions
    #
    if(! -r $spath) {

	$ret_status =  $RTN_DIR_UNREADABLE;
        last CLEANUP_COPY_LIST;

    }
    if(! -w $tpath) {

	$ret_status = $RTN_DIR_UNWRITABLE;
        last CLEANUP_COPY_LIST;

    }

    #
    # For a file dir/dir2/dir3/file we know that xcopy
    # won't create the directories. You would have to
    # create the entire tree under dir including a lot
    # of limbs that may not be wanted. Fortunatly the
    # only path to a file containing directory elements
    # that may not exist that this function gets passed
    # are are under db. We need to create the tree for
    # it anyway so if a path comes containing 'db' and
    # it doesn't exist yet go ahead and generate its tree.
    #
    $xcopyout = &mdep_get_tmpname();
    foreach $object (@list) {
   
        $opath = $spath.$MDEP_SEP.$object;
        &mdep_logger($MDEP_N_L, sprintf(" opath = %s\n", $opath));

        if(-d $opath) {

            $xdest = $tpath.$MDEP_SEP.$object;

            $sys_status = system("xcopy /s /e /i \"$opath\" \"$xdest\" >> \"$xcopyout\" 2>&1");
            if($sys_status) {

                #  Only return error status if the object that could not be
                #  copied still exists.
                #
                if(-e $opath) {
                    open(XCOPYOUT, "$xcopyout");
                    $line = <XCOPYOUT>;
                    close(XCOPYOUT);
                    if(-e $line) {
                        mdep_log_copy_error($xcopyout);
                        &mdep_logger($MDEP_E_L, sprintf(" %s NOT COPIED.\n", $line));
                        $ret_status = $RTN_COPY_FAILED;
                        last CLEANUP_COPY_LIST;
                    }
                }
            }
        }
        else {

            if($opath =~ /\\db\\/) {
                $xdest = $tpath.$MDEP_SEP.'db';
                $xdb = $spath.$MDEP_SEP.'db';
                
                if(! -d $xdest) {

                    if(system("xcopy  /t /e /s /k /i \"$xdb\" \"$xdest\" > \"$xcopyout\" ")) {

                        mdep_log_copy_error($xcopyout);

                        $ret_status =  $RTN_COPY_FAILED;
                        last CLEANUP_COPY_LIST;
                    }
                }
            }
              
            $xdest = $tpath.$MDEP_SEP.'db'.$MDEP_SEP;
            if(system("xcopy \"$opath\" \"$xdest\" > \"$xcopyout\" ")) {

                mdep_log_copy_error($xcopyout);

                $ret_status =  $RTN_COPY_FAILED;
                last CLEANUP_COPY_LIST;
            }
        }
    }

    &mdep_rmfile($xcopyout);
    $ret_status =  $RTN_COPY_OK;

  } # CLEANUP_COPY_LIST

  return $ret_status;
}

sub mdep_path_equal {
 
    local($source,$target) = @_;
    local($ret_status);
 
CLEANUP_PATH_EQUAL: {
    if(!$source || !$target) {
 
        $ret_status =  0;
        last CLEANUP_PATH_EQUAL;
    }
 
    if(lc($source) eq lc($target)) {
        $ret_status = 1;
        last CLEANUP_PATH_EQUAL;
    }

    $ret_status = 0;

  } # CLEANUP_PATH_EQUAL
  return $ret_status
}
 

sub mdep_is_locked {

    local($tag) = @_;
    local($status);
    local($ret_status);
    local($tmpfile);

CLEANUP_IS_LOCKED: { # Always return at end of this block.

    if($storage_dir eq "") {

	$ret_status = -1;
	last CLEANUP_IS_LOCKED;
    }
    $tmpfile = &mdep_get_tmpname();
    $status = system(
       "$MDEP_CLEARTOOL lslock -vob:$tag > $tmpfile 2>&1");

    if(!$status) {

	#
	# It failed. Try and determine if it was due to lock alread held
        # or another failure.
	#
	unless(open(LOCK_TMP,$tmpfile)) {

	    #
	    # Only thing I can think of is they ran out of file 
	    # descriptors. Return something that says we don't know 
	    # what the state of the lock is.
	    #
	    $ret_status = -1;
	    last CLEANUP_LS_LOCKED;
	}

        if(!grep(/Locked for all users/,@lines = <LOCK_TMP>)) {

	    $ret_status = 0;
        }
	else {

	    $ret_status = 1;
	}
    }
    
  } # CLEANUP_IS_LOCKED Always return here

    &mdep_rmfile($tmpfile);
    close(LOCK_TMP);
    return $ret_status;
}

#
# mdep_lock_vob
# Inputs:
#   $storage_dir
#     The location of the storage area
#   @exclude
#     A list of users to exclude
# Outputs:
#   None
# Returns:
# References:
#   None
# Modifies:
#   None
# Calls:
#   None
# Description:
#   Lock the storage area $storage_dir. If it can't be locked find out
#   if its because its already locked. Replace and nusers may be specified.
#
sub mdep_lock_vob {


    local(*tag,*storage_dir,*replace,*comment,*excludes) = @_;
    local($excludestr);               # Joined excludes
    local($nusers) = "";              # Foramtted nusers arguments.
    local($status);                   # Return status
    local(@cmdbuf);                   # Buffer to catch mdep_command output.
    local($tmpfile);                  # Put lock command output here
    local($line);                     # Line buffer for parsing tmpfile
    local($doreplace);                # Real replace argument
    local($ret_status);               # Return status

    $ret_status = $RTN_NO_STATUS_SET;

CLEANUP_LOCK_VOB: { # Always return at end of this block.

    #
    # Check inputs
    #
    if($storage_dir eq "") {

	$ret_status = $RTN_BAD_PARAMETERS;
	last CLEANUP_LOCK_VOB;
    }

    if($#excludes >= 0) {

	$excludestr = join(',',@excludes);
	$nusers = '-nusers '.$excludestr;
    }

    if($replace eq $MDEP_NO_REPLACE_LOCK) {

	$doreplace = "";
    }
    else {
  
        $doreplace = $replace;
    }
    #
    # Attempt the lock catching output. If it failes we parse the output
    # to try and understand why.
    #
    $tmpfile = &mdep_get_tmpname();
    $status = system(
    "$MDEP_CLEARTOOL lock -c \"$comment\" $doreplace $nusers vob:$tag  > $tmpfile 2>&1");
    if($status) {

	#
	# It failed. Try and determine if it was due to lock alread held
        # or another failure.
	#
	unless(open(LOCK_TMP,$tmpfile)) {

	    #
	    # Only thing I can think of is they ran out of file 
	    # descriptors. Return something that says we don't know 
	    # what the state of the lock is.
	    #
	    $ret_status = $RTN_LOCK_FAILED;
	    last CLEANUP_LOCK_VOB;
	}

	#
	# Look for the string that says its already locked.
	#
	foreach $line (<LOCK_TMP>) {

	    if($line =~ /.*Lock on VOB database.*/) {
		
		#
		# Yep. It was locked.
		#
		$ret_status = $RTN_LOCK_WAS_LOCKED;
		last CLEANUP_LOCK_VOB;

	    }
	}
	
	#
	# Some other kind of error. Return generic failure.
	#
	$ret_status = $RTN_LOCK_FAILED;
	last CLEANUP_LOCK_VOB;
    }

    $ret_status = $RTN_LOCK_OK;

  } # CLEANUP_LOCK_VOB Always return here

    &mdep_rmfile($tmpfile);
    close(LOCK_TMP);
    return $ret_status;
}

#
# mdep_unlock_vob
# Inputs:
#   $storage_dir
#     The location of the storage area
# Outputs:
#   None
# Returns:
# References:
#   None
# Modifies:
#   None
# Calls:
#   None
# Description:
#   Unock the storage area $storage_dir. If it can't be locked find out
#   if its because its already locked. The user may want to know.
#
sub mdep_unlock_vob {

    local(*tag,*comment) = @_;  # The storage area
    local($status);               # Return status
    local(@cmdbuf);               # Buffer to catch mdep_command output.
    local($tmpfile);              # Put lock command output here
    local($line);                 # Line buffer for parsing tmpfile
    local($ret_status);           # Return status

    $ret_status = $RTN_NO_STATUS_SET;

CLEANUP_UNLOCK_VOB: { # Always return at end of this block.

    #
    # Check inputs
    #
    if($tag eq "") {

	$ret_status = $RTN_BAD_PARAMETERS;
	last CLEANUP_UNLOCK_VOB;
    }

    #
    # Attempt the lock catching output. If it failes we parse the output
    # to try and understand why.
    #
    $tmpfile = &mdep_get_tmpname();
    $status = system("$MDEP_CLEARTOOL unlock -c \"$comment\" vob:$tag > $tmpfile 2>&1");

    if($status) {

	#
	# It failed. Try and determine if it was due to lock alread unlocked
        # or another failure.
	#
	unless(open(UNLOCK_TMP,$tmpfile)) {

	    #
	    # Only thing I can think of is they ran out of file descriptors.
            # Return something that says we don't know what the state of
	    # the lock is.
	    $ret_status =  $RTN_UNLOCK_FAILED;
	    last CLEANUP_UNLOCK_VOB;
	}

	#
	# Look for the string that says its already locked.
	#
	foreach $line (<UNLOCK_TMP>) {
	    
	    if($line =~ /.*Object is not locked.*/) {
		
		#
		# Yep. It was locked.
		#
		$ret_status = $RTN_LOCK_WAS_UNLOCKED;
		last CLEANUP_UNLOCK_VOB;

	    }
	}

	#
	# Some other kind of failure.
	#
	$ret_status = $RTN_UNLOCK_FAILED;
	last CLEANUP_UNLOCK_VOB;
    }

    $ret_status = $RTN_UNLOCK_OK;

  } # CLEANUP_UNLOCK_VOB Always return here

    close(UNLOCK_TMP);
    &mdep_rmfile($tmpfile);
    return $ret_status;
}

sub mdep_get_vob_ownership {

    return $RTN_NOT_SUPPORTED;
}          

sub mdep_set_ownership {

    local($storage_dir) = @_[0];           # Storage dir


    return $RTN_NOT_SUPPORTED;


}

sub mdep_reset_ownership {

    local($sorage_dir) = @_[0];   # Storage dir

    return $RTN_NOT_SUPPORTED;

}

sub mdep_map_error_type {

    local($estring) = @_[0];      # Error string.

    #
    # On unix they stay the same.
    #
    return $estring;
}


sub mdep_open_log_file {

    local($lpath) = @_[0];        # Path to the log file
    local($ret_status);           # Return status
    local($oldfh);                # Place to save the current file handle

CLEANUP_OPEN_LOG_FILE: { # Always return at end of this block.
    unless(open(LOG_FILE_DESC,">>$lpath")) {
	$ret_status =  $RTN_FILE_OPEN_FAILED;
	last CLEANUP_OPEN_LOG_FILE;
    }
    #
    # We want to force out all writes to the log file
    #
    $oldfh = select(LOG_FILE_DESC);$| = 1;select($oldfh);
 
    $ret_status = $RTN_FILE_OPEN_OK;

  } # CLEANUP_OPEN_LOG_FILE Always return here

    return $ret_status;
}



sub mdep_umount {

    local($vob_tag) = @_[0];       # Tag to unmount
    local($status);                # System status
    local($ret_status);            # Return status

CLEANUP_UMOUNT: { # Always return at end of this block.

    if($vob_tag eq "") {

	$ret_status = $RTN_BAD_PARAMETERS;
	last CLEANUP_UMOUNT;
    }
    $status = &system_redirect("$MDEP_CLEARTOOL umount $vob_tag");

    if($status) {

	return $RTN_UMOUNT_FAILED;
	last CLEANUP_UMOUNT;
    }

    return $RTN_UMOUNT_OK;

  } # CLEANUP_UMOUNT Always return here
}

sub mdep_mount {

    local($vob_tag) = @_[0] ;       # Tag to mount
    local($status);                 # System status
    local($ret_status);            # Return status

CLEANUP_MOUNT: { # Always return at end of this block.

    if($vob_tag eq "") {

	$ret_status = $RTN_BAD_PARAMETERS;
	last CLEANUP_MOUNT;
    }

    $status = system("$MDEP_CLEARTOOL mount $vob_tag");

    if($status) {

	return $RTN_MOUNT_FAILED;
	last CLEANUP_MOUNT;
    }

    return $RTN_MOUNT_OK;

  } # CLEANUP_MOUNT Always return here
}

sub mdep_real_log_msg {

    local($type) = @_[0];            # Ignored by unis
    local($message) = @_[1];         # Message
    local($ret_status);              # Return status
    local($timex);                    # Current time
    local($fstr);                    # General format buffer;

    #
    # Prefix the time to the message and put it out.
    #
    $timex = &mdep_date_fmt_time_long(time());
    $fstr = sprintf("%s %s",$timex,$message);
    print LOG_FILE_DESC "$fstr";



} 

sub mdep_log_event {

    local($vob_tag) = shift(@_);
    local($status) = @_;
    local($fstr);

    if($status == 0) {

        $arguments = sprintf("\"snapshot of %s\" suceeded",$vob_tag);
    }
    elsif(($status == 1) || ($status == 2)) {
        $arguments = sprintf("\"snapshot of %s\" failed %s",$vob_tag,$MDEP_LOG_FILE);
    }
    system("$MDEP_IMSGLOG $arguments");
} 

sub mdep_is_tag_valid {
 
    local($vobtag) = @_[0];       # Tag to validate
    local($hostname) = @_[1];
    local($status);               # General status
    local($ret_status);           # Return status
    local(@local_tags);
    
CLEANUP_IS_TAG_VALID: { # Always return at end of this block.

    if($vobtag eq "") {

	$ret_status = $RTN_NOT_OK;
	last CLEANUP_IS_TAG_VALID;
    }
    
    $status = &mdep_get_local_tags(*hostname,*local_tags);
    if($status ne $RTN_OK) {

        $ret_status = $RTN_NOT_OK;
        last CLEANUP_IS_TAG_VALID;
    }

    foreach $tag (@local_tags) {
        chop $tag;
        if($tag eq $vobtag) {
            $ret_status = $RTN_OK;
            last CLEANUP_IS_TAG_VALID;
        }
    }

    $ret_status = $RTN_NOT_OK;
  } # CLEANUP_IS_TAG_VALID Always return here
  return $ret_status;
}


sub mdep_get_login_id {

    local($id);                 # Id to return

    $id = $ENV{'USERNAME'};
    return $id;
}

sub mdep_privileged {
  
    return(1);
}

	
$MDEP_LOG_FORMAT              = "%s(%d): %s: %s";
$MDEP_NOTIFY_FORMAT           = "%s: %s";

#
# mdep_log_notification returns whether it sent anything or
# not to those who are interested.
#
$MDEP_NOTIFY_SENT             = "Notify Sent";
$MDEP_NOTIFY_SENT             = "Notify Not Sent";

#
# mdep_log_msg does likewise
#
#
$MDEP_MSG_LOGGED              = "Message Logged";
$MDEP_MSG_LOGGED              = "Message Not Logged";

#
# Whether the log in the var/adm/atria/log directory is open or
# not.
#
$MDEP_LOG_NOT_OPEN            = 0;
$MDEP_LOG_IS_OPEN             = 1;
$mdep_log_open                =  $MDEP_LOG_NOT_OPEN;



$MDEP_NT_SUCCESS_STR          = "SUCCESS";
$MDEP_NT_SUCCESS_STR          = "FAIL";




# 
# Function: mdep_logger_string
# Inputs:
#   $mtype
#     Error type
# Outouts:
#   None
# Returns:
#   Appropriate string
# References:
#   None
# Modifies:
#   None
# Calls:
#   None
# Description:
#   Returns the appropriate message string based on set bits in $mtype.
#  
sub mdep_logger_string {

    local($type)= @_[0];      # Message type information

CLEANUP_LOGGER_STRING: { # Always return at end of this block.
    if($type & $MDEP_ERROR) {

	$ret_status = $MDEP_ERROR_STR;
        last CLEANUP_LOGGER_STRING;
    }
    elsif($type & $MDEP_FATAL) {

	$ret_status = $MDEP_FATAL_STR;
        last CLEANUP_LOGGER_STRING;
    }
    elsif($type & $MDEP_WARN) {

	$ret_status = $MDEP_WARN_STR;
        last CLEANUP_LOGGER_STRING;
    }
    elsif($type & $MDEP_NOTE) {

	$ret_status = $MDEP_NOTE_STR;
        last CLEANUP_LOGGER_STRING;
    }

    $ret_status = $MDEP_UNKNOWN_STR;



  } # CLEANUP_LOGGER_STRING Always return here

    return $ret_status;

}



# 
# Function: mdep_logger
# Inputs:
#   $mtype
#     Error type and routing information
#   $message
#     Message string
# Outouts:
#   None
# Returns:
#   None 
# References:
#   None
# Modifies:
#   None 
# Calls:
#   &mdep_log_msg
#   &mdep_log_notification
# Description:
#   All error messages for the snap module come through here. The first
#   argument contains information about the messages type and where it
#   should go. Basically, on unix errors are of type 'ERROR', WARNING, 
#   and 'NOTE' and go the log file in var/adm/log. An additional type
#   'FATAL' gets converted to a type 'ERROR' with the 'FATAL' string
#   included in the message. On NT messages go through its native 
#   message logging facility which accepts only two types -  failure
#   and success. So, on NT 'FATAL', ERROR', and 'WARNING' messges
#   get mapped to 'FAILURE' and 'NOTE' get mapped to 'SUCCESSS'. The 
#   message itself contains the actual type 'FATAL', 'ERROR', WARNING',
#   or 'NOT' in either case. The message is formatted here and sent
#   the appropiate log via &mdep_log_msg.
#
#   On Unix only...
#   The mtype argument also contains information on wether to send
#   notification to interested users or not. While the program is 
#   running a seperate notification log is maintained for each replica 
#   snap as well as a 'root' log for things that happen outside of a snap.
#   The formatted message may be sent to the notification log, just 
#   the message log described above or both. The formatted message
#   is sent to &mdep_log_notification which decides whether to put it out
#   to the current notification log or not.
#  
sub mdep_logger {

    local($mtype) = @_[0];       # Error type and routing information
    local($message) = @_[1];     # Message
    local($etype);               # Error type string
    local($estring);             # Error type string
    local($lfstr);               # Format string for log file
    local($nfstr);               # Format string for notification file

CLEANUP_LOGGER: { # Always return at end of this block.
    #
    # Format the message. First get the correct string representation
    # for the error level.
    #
    if($message eq "") {
    
        return;
    }
    $estring = &mdep_logger_string($mtype);
    $lfstr = sprintf($MDEP_LOG_FORMAT,$SNAP_PROGRAM,$$,$estring,$message);
    #
    # Send the message off to the logger.
    #
    &mdep_log_msg($mtype,$lfstr);
    
  } # CLEANUP_LOGGER Always return here

}

# 
# Function: mdep_log_msg
# Inputs:
#   $mtype
#     Error type and routing information
#   $message
#     Message string
# Outouts:
#   None
# Returns:
#   $RTN_BAD_PARAMETERS
#   $MDEP_MSG_LOGGED
#   $MDEP_MSG_NOT_LOGGED
# References:
#   $mdep_log_open
# Modifies:
#   None 
# Calls:
#   &mdep_logger_string
#   &mdep_map_error_type
#   &mdep_log_msg
# Description:
#   This function wraps the call to the machine dependent &mdep_log_msg
#   function. It checks for bad arguments, calls &mdep_map_error_type to
#   map the snap error types to ones the machine type knows about and makes
#   the &mdep_log_msg call.
#  
sub mdep_log_msg {

    local($mtype) = @_[0];        # Message type information
    local($message) = @_[1];      # Message
    local($estring);              # String error type
    local($mapped);               # Mapped estring
    local($ret_status);           # Return status

CLEANUP_LOG_MSG: { # Always return at end of this block.
    #
    # Check the input
    #
    if(($mtype eq "") ||
       ($message eq "")) {

	$ret_status = $RTN_BAD_PARAMETERS;
        last CLEANUP_LOG_MSG;
    }
    #
    # See if it gets logged.
    #
    if($mtype & $MDEP_LOG) { 
        $estring = &mdep_logger_string($mtype);
        &mdep_real_log_msg($estring,$message);
	$ret_status = $MDEP_MSG_LOGGED;
    }
    else {
	$ret_status = $MDEP_MSG_NOT_LOGGED;
    }

  } # CLEANUP_LOG_MSG Always return here

    return $ret_status;
}

#
# Notification stubs....
#
sub mdep_log_notification {

    local($mtype) = @_[0];       # Error type and routing information
    local($message) = @_[1];     # Message

    return $MDEP_NO_NOTIFY_SENT;
}

sub mdep_get_host_parameters {

    return $RTN_NOT_SUPPORTED;
}

sub mdep_put_root_on_user_list {

    return 0;
}

sub mdep_put_on_user_list {

   return 0;
}

sub mdep_init_rep_file {

    local($rep_uuid) = @_;         # Replica uuid of snapping repllica

    return 0;
}

sub mdep_init_root_file {

    return 0;;
}

sub mdep_reopen_root_file {

    return 0;
}

sub mdep_reopen_rep_file {

    local($file) = @_;          # The file to reopen

    return 0;
}

sub mdep_close_rep_file {

    return 0;
}

sub mdep_close_root_file {

    return 0;
}

sub mdep_notify_user {

    local($user) = @_[0];           # The user 
    local($list) = @_[1];           # List of files to send

    return 0;
}

sub mdep_send_notification {

    return 0;
}
    


sub mdep_check_deferred_del {
 
    local($storage_dir) = @_[0];# Replica storage area
    local($confpath);           # Path to vob_server conf file
    local($line);               # Line buffer for parsing file
    local($ret_status);         # Return status
CLEANUP_CHECK_DEFFERED_DEL: { # Always return at end of this block.
 
    $confpath = $storage_dir.$MDEP_SEP.$MDEP_VOB_SERVER_CONF;
    unless(open(VOB_CONF,$confpath)) {
        $ret_status = $RTN_OPEN_FAILED;
        last CLEANUP_CHECK_DEFFERED_DEL;
    }
 
    $ret_status = $RTN_NOT_SET;
 
    foreach $line (<VOB_CONF>) {
        chop $line;
        if($line =~ /$MDEP_DEFFERED_DEL_PARAMETER=(.*)/) {
            if(lc($1) eq lc('yes')) {
 
                $ret_status = $RTN_SET;
                last CLEANUP_CHECK_DEFFERED_DEL;
            }
        }
    }
 
  } # CLEANUP_CHECK_DEFFERED_DEL Always return here
 
    close(VOB_CONF);
    return $ret_status;
}

sub mdep_date_fmt_time_long {

    local($time) = @_;
    local($sec, $min, $hour, $day, $mon, $year);
    local($date_str);


    ($sec, $min, $hour, $day, $mon, $year) = localtime($time);
    $year = $year + 1900;
    $date_str = sprintf("%.2d-%.2d-%.4d.%.2d.%.2d.%.2d",
                        $day, $mon+1, $year,
                        $hour, $min, $sec);
    return $date_str;
}

sub mdep_is_uncname {

    local($path) = @_;

    if($path =~ /^\\\\/) {

        return 1;
    }
    else {

        return 0;
    }
}


sub mdep_move_temp_to_dest {

    local($from,$to) = @_;
    local($status) = 0;

    if(!$from || !$to) {
	return 0;
    }
    $status = system("$MDEP_MOVE \"$from\" \"$to\"");
    return $status;
}


sub mdep_scheduled_for_snap {

    local(*tag,*snap_to) = @_;
    local($count);
    local($tmpname);
    local($ret_status) = 0;

CLEANUP_SCHEDULED_FOR_SNAP: {
    if(!$tag) {
	$ret_status = -1;
	last CLEANUP_SCHEDULED_FOR_SNAP;
    }

    $tmpname = &mdep_get_tmpname();
    print "$MDEP_VOB_SETUP lsvob -long $tag\n";
    system("$MDEP_VOB_SETUP lsvob -long $tag > $tmpname 2>&1");
    unless(open(TMPNAME,$tmpname)) {
        $ret_status = -1;
        last CLEANUP_SCHEDULED_FOR_SNAP;
    }
    while(<TMPNAME>) {
        chop;
        if(/Snap To                  (.*)/) {
   	    $snap_to = $1; 
	    $ret_status = 1;
	    last CLEANUP_SCHEDULED_FOR_SNAP;
	}
    }
    if($ret_status != 1) {
	$ret_status = 0;
    }

  } # CLEANUP_SCHEDULED_FOR_SNAP

  close($tmpname);
  &mdep_rmfile($tmpname);
  return $ret_status;

}    

sub mdep_remove_snap_attribute {

    local($tag,$storage,$who) = @_;
    local($ret_status);
    local($st);
    local($unlocked) = 0;
    local(@excludes);
    local($comment);
    local($replace);
    local($myid);

CLEANUP_REMOVE_SNAP_ATTRIBUTE: {

    if(!$tag || !$storage) {
	$ret_status = 0;
	last CLEANUP_REMOVE_SNAP_ATTRIBUTE;
    }
    
    $st = &mdep_is_locked($storage);

    if($st == -1) {
	$ret_status = 0;
	last CLEANUP_REMOVE_SNAP_ATTRIBUTE;
    }
    if($st == 1) {

	$myid = &mdep_get_login_id();
	@excludes = ("$myid");
        $comment = sprintf(
		  "%s locking for all but %s to remove snap attribute",
		   $who,
		   $myid);
	$replace = $MDEP_REPLACE_LOCK;
	$st = &mdep_lock_vob(*tag,*storage,*replace,*comment,*excludes);

	if($st ne $RTN_LOCK_OK) {
	    $ret_status = 0;
	    last CLEANUP_REMOVE_SNAP_ATTRIBUTE;
	}

	$unlocked++;
    }
    &system_redirect("$MDEP_VOB_SETUP rmparam $tag");

    $status = &mdep_scheduled_for_snap(*tag,*snap_to);
    if($status != 0) {
	$ret_status = -1;
    }

  } # CLEANUP_REMOVE_SNAP_ATTRIBUTE

    if($unlocked) {
	@excludes = ();
        $comment = sprintf("%s relocking for all after removing snap attribute",$who);
	$replace = $MDEP_REPLACE_LOCK;

	&mdep_lock_vob(*tag,*storage,*replace,*comment,*excludes);
    }
    return $ret_status;
}

sub mdep_same_hosts {

# We are on a first name basis here. wjs.

    my($h1,$h2) = @_;
    $h1 =~ s/^([^\.]+)\..+$/$1/;
    $h2 =~ s/^([^\.]+)\..+$/$1/; 
    if($h1 =~ /$h2/i) {
	return 1;
    }
    return 0;
}
